diff -uwr sourceold/scripts/tcw_game.cpp source/scripts/tcw_game.cpp
--- sourceold/scripts/tcw_game.cpp	2012-02-08 00:15:43.935546800 +0800
+++ source/scripts/tcw_game.cpp	2012-06-09 08:11:12.311523400 +0800
@@ -1216,13 +321,19 @@
 	Commands->Send_Custom_Event(obj,Commands->Find_Object(id),msg,prm,0);
 }
 
-void tcw_test::Created(GameObject *obj)
+void tcw_Spawner_Enable_Timer::Created(GameObject *obj)
 {
-	Console_Input("msg script created");
+	Commands->Start_Timer(obj,this,Get_Float_Parameter("Enable_After_Seconds"),1001);
+}
+void tcw_Spawner_Enable_Timer::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 1001)
+	{
+		Commands->Enable_Spawner(Get_Int_Parameter("SpawnerID"),true);
+	}
 }
 
-
-ScriptRegistrant<tcw_test> tcw_test_Registrant("tcw_test","");
+ScriptRegistrant<tcw_Spawner_Enable_Timer> tcw_Spawner_Enable_Timer_Registrant("tcw_Spawner_Enable_Timer","Enable_After_Seconds=1000:float,SpawnerID=0:int");
 ScriptRegistrant<tcw_destroyed_send_custom> tcw_destroyed_send_custom_Registrant("tcw_destroyed_send_custom","Message=1000:int,SendID=1000:int,Param=1:int");
 ScriptRegistrant<tcw_dm_map_tech1> tcw_dm_map_tech1_Registrant("tcw_dm_map_tech1","");
 ScriptRegistrant<tcw_dm_map_tech2> tcw_dm_map_tech2_Registrant("tcw_dm_map_tech2","");
@@ -1230,21 +341,7 @@
 ScriptRegistrant<tcw_zone_teleport_random_id> tcw_zone_teleport_random_id_Registrant("tcw_zone_teleport_random_id","ID1=1:int,ID2=2:int,ID3=3:int");
 ScriptRegistrant<tcw_Death_Blowup_Building> tcw_Death_Blowup_Building_Registrant("tcw_Death_Blowup_Building","Type=0:int,Building_Name=TCW:string");
 ScriptRegistrant<tcw_Spikemap_Get_CaptureGuy> tcw_Spikemap_Get_CaptureGuy_Registrant("tcw_Spikemap_Get_CaptureGuy","Type=0:int");
-ScriptRegistrant<tcw_Buy_Beacon_Ion> tcw_Buy_Beacon_Ion_Registrant("tcw_Buy_Beacon_Ion","Type=2:int");
-ScriptRegistrant<tcw_Enable_Refill> tcw_Enable_Refill_Registrant("tcw_Enable_Refill","");
 ScriptRegistrant<tcw_There_Must_Be_Engineer> tcw_There_Must_Be_Engineer_Registrant("tcw_There_Must_Be_Engineer","");
-ScriptRegistrant<tcw_Tiberium_Deposit_New> tcw_Tiberium_Deposit_New_Registrant("tcw_Tiberium_Deposit_New","");
-ScriptRegistrant<tcw_Tiberium_Harvester_New> tcw_Tiberium_Harvester_New_Registrant("tcw_Tiberium_Harvester_New","");
-ScriptRegistrant<tcw_Tiberium_Field_New> tcw_Tiberium_Field_New_Registrant("tcw_Tiberium_Field_New","Zonetype=0:int");
 ScriptRegistrant<tcw_Map_Intro> tcw_Map_Intro_Registrant("tcw_Map_Intro","Red=1:int,Green=1:int,Blue=1:int,Intro1=Line1:string,Intro2=Line2:string,Intro3=Line3:string,Intro4=Line4:string,Intro5=Line5:string");
-ScriptRegistrant<tcw_Set_Spike_Team_Created> tcw_Set_Spike_Team_Created_Registrant("tcw_Set_Spike_Team_Created","Team=0:int");
 ScriptRegistrant<tcw_Custom_Win_Game_Credits> tcw_Custom_Win_Game_Credits_Registrant("tcw_Custom_Win_Game_Credits","");
-ScriptRegistrant<tcw_Point_Trickle> tcw_Point_Trickle_Registrant("tcw_Point_Trickle","Points=1:int,Delay=2.0:float");
-ScriptRegistrant<tcw_tiberium_spike_points> tcw_tiberium_spike_points_Registrant("tcw_tiberium_spike_points","");
-ScriptRegistrant<tcw_Tiberium_Deposit> tcw_Tiberium_Deposit_Registrant("tcw_Tiberium_Deposit","Deposit_Message:int");
-ScriptRegistrant<tcw_Tiberium_Field> tcw_Tiberium_Field_Registrant("tcw_Tiberium_Field","Cash:int,Time:float,TimerNum:int,Collected_Preset:string,Collected_Preset_Distance:float,Collected_Message:int,Nod_Preset_Green=TCW_Nod_Harvester_Player_Green:string,GDI_Preset_Green=TCW_GDI_Harvester_Player_Green:string,Nod_Preset_Blue=TCW_Nod_Harvester_Player_Blue:string,GDI_Preset_Blue=TCW_GDI_Harvester_Player_Blue:string,StartHarvest:int,StopHarvest:int");
 ScriptRegistrant<tcw_Credit_Trickle> tcw_Credit_Trickle_Registrant("tcw_Credit_Trickle","Credits=1:int,Delay=2.0:float");
-ScriptRegistrant<tcw_i_can_capture_spike> tcw_i_can_capture_spike_Registrant("tcw_i_can_capture_spike","");
-ScriptRegistrant<tcw_tiberium_spike_capture> tcw_tiberium_spike_capture_Registrant("tcw_tiberium_spike_capture","Spike_ID=123:int");
-ScriptRegistrant<tcw_tiberium_spike> tcw_tiberium_spike_Registrant("tcw_tiberium_spike","");
-ScriptRegistrant<tcw_Tiberium_Harvester> tcw_Tiberium_Harvester_Registrant("tcw_Tiberium_Harvester","Collected_Message:int,Refinery_Message:int,Cash_Limit:int,Cash_Type:int,Entire_Team:int");
\ No newline at end of file
diff -uwr sourceold/scripts/tcw_game.h source/scripts/tcw_game.h
--- sourceold/scripts/tcw_game.h	2012-02-08 00:15:44.309570300 +0800
+++ source/scripts/tcw_game.h	2012-06-09 08:11:12.182617100 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -11,140 +11,27 @@
 	with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-#pragma once
-
-class tcw_Tiberium_Harvester : public ScriptImpClass {
-	int driver;
-	int team;
-	int cash;
-	int ID;
-	void Created(GameObject *obj);
-	void Custom(GameObject *obj,int type,int param,GameObject *sender);
-	public: void Register_Auto_Save_Variables();
-};
-
-class tcw_tiberium_spike : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Custom(GameObject *obj,int type,int param,GameObject *sender);
-	public: void Register_Auto_Save_Variables();
-	void Damaged(GameObject *obj, GameObject *damager, float damage);
-	bool firstcapture;
-};
-
-class tcw_tiberium_spike_capture : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Entered(GameObject *obj, GameObject *enter);
-	void Exited(GameObject *obj, GameObject *exit);
-	void Timer_Expired(GameObject *obj, int number);
-	public: void Register_Auto_Save_Variables();
-	int capturer;
-	bool capturing;
-};
-
-class tcw_i_can_capture_spike : public ScriptImpClass {
-	void Created(GameObject *obj);
-};
 
-class tcw_Player_Attach_Dropweapons : public JFW_Object_Created_Hook_Base {
-	void ObjectCreateHook(GameObject *obj);
-	void Timer_Expired(GameObject *obj, int number);
-};
-
-class tcw_Player_Dropweapons : public ScriptImpClass {
-	void Destroyed(GameObject *obj);
-};
+#pragma once
 
 class tcw_Credit_Trickle : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 };
 
-class tcw_Tiberium_Field : public ScriptImpClass {
-	int ID;
-	void Created(GameObject *obj);
-	void Entered(GameObject *obj,GameObject *enter);
-	void Exited(GameObject *obj,GameObject *exit);
-	void Timer_Expired(GameObject *obj,int number);
-	public: void Register_Auto_Save_Variables();
-};
-
-class tcw_Tiberium_Deposit : public ScriptImpClass {
-	void Entered(GameObject *obj,GameObject *enter);
-};
-
-class tcw_tiberium_spike_points : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Custom(GameObject *obj,int type,int param,GameObject *sender);
-	public: void Register_Auto_Save_Variables();
-	bool firstcapture;
-};
-
-class tcw_Point_Trickle : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Timer_Expired(GameObject *obj,int number);
-	public: void Register_Auto_Save_Variables();
-	bool display;
-};
-
 class tcw_Custom_Win_Game_Credits : public ScriptImpClass {
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 };
 
-class tcw_Set_Spike_Team_Created : public ScriptImpClass {
-	void Created(GameObject *obj);
-};
-
 class tcw_Map_Intro : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj, int number);
 };
 
-class tcw_Tiberium_Field_New : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Entered(GameObject *obj, GameObject *enter);
-	void Exited(GameObject *obj, GameObject *exit);
-	public: void Register_Auto_Save_Variables();
-	int zonetype;
-};
-
-class tcw_Tiberium_Harvester_New : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Custom(GameObject *obj, int message, int param, GameObject *sender);
-	void Timer_Expired(GameObject *obj, int number);
-	public: void Register_Auto_Save_Variables();
-	float tiberiumvalue;
-	bool harvesting;
-	bool hasgreen;
-	bool hasblue;
-	int driverid;
-	int team;
-};
-
-class tcw_Tiberium_Deposit_New : public ScriptImpClass {
-	void Entered(GameObject *obj, GameObject *enter);
-};
-
 class tcw_There_Must_Be_Engineer : public ScriptImpClass {
 	void Created(GameObject *obj);
 }; 
 
-class tcw_Enable_Refill : public ScriptImpClass {
-	void Created(GameObject *obj);
-}; 
-
-class tcw_Buy_Beacon_Ion : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Timer_Expired(GameObject *obj, int number);
-	void Poked(GameObject *obj, GameObject *poker);
-	void Custom(GameObject *obj, int message, int param, GameObject *sender);
-	public: void Register_Auto_Save_Variables();
-	bool charging;
-	bool ready;
-	bool allowpoke;
-	int ionholder;
-	int type;
-}; 
-
 class tcw_Spikemap_Get_CaptureGuy : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Poked(GameObject *obj, GameObject *poker);
@@ -185,14 +72,12 @@
 	void Destroyed(GameObject *obj);
 }; 
 
-class tcw_test : public ScriptImpClass {
+class tcw_Spawner_Enable_Timer : public ScriptImpClass {
 	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj, int number);
 };
 
 
 
-
-
-
 
 
Only in source/scripts: tcw_general.cpp
Only in source/scripts: tcw_general.h
Only in source/scripts: tcw_mcv_escort.cpp
Only in source/scripts: tcw_mcv_escort.h
diff -uwr sourceold/scripts/tcw_player.cpp source/scripts/tcw_player.cpp
--- sourceold/scripts/tcw_player.cpp	2012-02-02 09:44:43.153320300 +0800
+++ source/scripts/tcw_player.cpp	2012-06-09 08:11:12.339843700 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -19,7 +19,6 @@
 #include "gmgame.h"
 #endif
 
-
 void tcw_Grant_Powerup_Created::Created(GameObject *obj)//with this script we can do to players what we want easily
 {
 	map_low_grav = false;	map_dm_tech1 = false;	map_dm_tech2 = false;	map_dm_tech3 = false;	map_coop_gdi = false;	map_coop_nod = false;	
@@ -214,10 +213,9 @@
 		}
 	}
 
-	Commands->Start_Timer(obj,this,1.5f,1003);//give MapCredits
-
-	upgrade_composit_armor_available = false;
+	upgrade_composit_armor_available = false; upgrade_powerpacks_available = false;
 	if (Find_Object_By_Preset(2,"TCW_Tech_Composit_Armor_Available")) {	upgrade_composit_armor_available = true; }
+	if (Find_Object_By_Preset(2,"TCW_Tech_Power_Packs_Available")) { upgrade_powerpacks_available = true; }
 
 	int sniperlimit = 2;
 
@@ -357,7 +355,7 @@
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_rifle_squad_2.wav",1);
-				char player[250]; sprintf(player,"%s: Rifle squad ready.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: Reporting in.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
@@ -637,7 +635,7 @@
 				else if (random == 2)
 				{
 					Create_2D_WAV_Sound_Team("purchase_gdi_sniper_2.wav",1);
-					char player[250]; sprintf(player,"%s: Sniper team ready.",Get_Player_Name(obj));
+					char player[250]; sprintf(player,"%s: I got'm in my scope.",Get_Player_Name(obj));
 					Send_Message_Team(1,255,204,0,player);
 				}
 				else if (random == 3)
@@ -684,6 +682,11 @@
 	{
 		if (Commands->Get_Player_Type(obj) == 1)
 		{
+			if (upgrade_powerpacks_available) 
+			{ 
+				Commands->Start_Timer(obj,this,3.0f,1007); //powerpacks check move
+				commandocurrpos = Commands->Get_Position(obj);//using this for checking the distance travel on zonetrooper as well
+			}
 			if (random == 1)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_1.wav",1);
@@ -693,7 +696,7 @@
 			else if (random == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_gdi_zonetrooper_2.wav",1);
-				char player[250]; sprintf(player,"%s: Troopers ready for action.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: Shut this party down.",Get_Player_Name(obj));
 				Send_Message_Team(1,255,204,0,player);
 			}
 			else if (random == 3)
@@ -785,8 +788,8 @@
 				}
 				else if (random == 3)
 				{
-					Create_2D_WAV_Sound_Team("purchase_nod_commando_2.wav",1);
-					char player[250]; sprintf(player,"%s: Ready for assignment.",Get_Player_Name(obj));
+					Create_2D_WAV_Sound_Team("purchase_nod_commando_3.wav",1);
+					char player[250]; sprintf(player,"%s: It's play time.",Get_Player_Name(obj));
 					Send_Message_Team(1,255,204,0,player);
 				}
 			}
@@ -872,13 +875,13 @@
 			else if (rnd == 2)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_2.wav",0);
-				char player[250]; sprintf(player,"%s: Purifier ready.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: Exterminate the weak.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (rnd == 3)
 			{
 				Create_2D_WAV_Sound_Team("purchase_nod_blackhand_flame_3.wav",0);
-				char player[250]; sprintf(player,"%s: The flame shall purify.",Get_Player_Name(obj));
+				char player[250]; sprintf(player,"%s: They cannot hide from the Black Hand.",Get_Player_Name(obj));
 				Send_Message_Team(0,255,0,0,player);
 			}
 			else if (rnd == 4)
@@ -1080,6 +1083,30 @@
 			Commands->Start_Timer(obj,this,1.0f,1006);
 		}
 	}
+	else if (number == 1007)//used for zonetrooper repair powerpacks
+	{
+		commandonewpos = Commands->Get_Position(obj);
+		float commandotraveldistance = Commands->Get_Distance(commandocurrpos,commandonewpos);
+		if (commandotraveldistance <= 0.1f)	// not moved...
+		{
+			if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Zonetrooper") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Zonetrooper_Low") == 0) && (Commands->Get_Player_Type(obj) == 1))
+			{
+				float maxhp = Commands->Get_Max_Health(obj);
+				float maxap = Commands->Get_Max_Shield_Strength(obj);
+				float curhp = Commands->Get_Health(obj);
+				float curap = Commands->Get_Shield_Strength(obj);
+				if (curhp < maxhp)
+				{
+					Commands->Set_Health(obj,curhp+5.0f);
+				}
+				if (curap < maxap)
+				{
+					Commands->Set_Health(obj,curap+5.0f);
+				}
+				Commands->Start_Timer(obj,this,3.0f,1007);
+			}
+		}
+	}
 }
 void tcw_Grant_Powerup_Created::Killed(GameObject *obj, GameObject *shooter)
 {
@@ -1157,6 +1184,35 @@
 	{ 
 		if (param == 1)
 		{
+			if (strcmp(Commands->Get_Preset_Name(sender),"TCW_GDI_Command_Post") == 0)
+			{
+				if (Commands->Get_Player_Type(obj) == 0)//only check nod units when the command post checks
+				{
+					if (!revealed)
+					{
+						Commands->Enable_Stealth(obj, false);
+						Commands->Start_Timer(obj,this,2.0f,1004);//enable stealh again
+						if (playdetected)
+						{
+							if (Commands->Get_Player_Type(obj) == 0)
+							{
+								Create_2D_WAV_Sound_Team("stealth_unit_detected_gdi.wav",1);
+								Send_Message_Team(1,255,204,0,"Stealth unit detected.");
+							}
+							else if (Commands->Get_Player_Type(obj) == 1)
+							{
+								Create_2D_WAV_Sound_Team("stealth_unit_detected_nod.wav",0);
+								Send_Message_Team(0,255,0,0,"Stealth unit detected.");
+							}
+							playdetected = false;
+							Commands->Start_Timer(obj,this,10.0f,1005);//playdetected true
+						}	
+						revealed = true;
+					}
+				}
+			}
+			else
+			{
 			if (Commands->Get_Player_Type(sender) != Commands->Get_Player_Type(obj))
 			{
 				Vector3 mypos = Commands->Get_Position(obj);
@@ -1190,6 +1246,7 @@
 			}
 		}
 	}
+	}
 	else if (message == 1005)//Tech Composit Armor Upgrade complete
 	{
 		if (param == 1)
@@ -1206,6 +1263,15 @@
 			Send_Message_Player(obj,255,204,0,"Unit Upgraded: Composite Armor.");
 		}
 	}
+	else if (message == 1006)//Tech Powerpacks Upgrade complete
+	{
+		if (param == 1)
+		{
+			Commands->Start_Timer(obj,this,1.0f,1007);//start regeneration if not moved
+			Create_2D_WAV_Sound_Player(obj,"gdi_tech_unit_upgraded.wav");
+			Send_Message_Player(obj,255,204,0,"Unit Upgraded: Power Packs.");
+		}
+	}
 }
 void tcw_Grant_Powerup_Created::Register_Auto_Save_Variables()
 {
@@ -1222,11 +1288,4 @@
 	Auto_Save_Variable(&map_coop_nod,sizeof(map_coop_nod),11);
 }
 
-void tcw_I_Have_Ion_Cannon_Beacon::Destroyed(GameObject *obj)
-{
-	Commands->Send_Custom_Event(obj,Find_Object_With_Script("tcw_Buy_Beacon_Ion"),100101,1,0);
-}
-
-
-ScriptRegistrant<tcw_I_Have_Ion_Cannon_Beacon> tcw_I_Have_Ion_Cannon_Beacon_Registrant("tcw_I_Have_Ion_Cannon_Beacon","");
 ScriptRegistrant<tcw_Grant_Powerup_Created> tcw_Grant_Powerup_Created_Registrant("tcw_Grant_Powerup_Created","Weapon1=TCW_POW_Knife:string,Weapon2=0:string,Weapon3=0:string,Weapon4=0:string,Weapon5=0:string");
\ No newline at end of file
diff -uwr sourceold/scripts/tcw_player.h source/scripts/tcw_player.h
--- sourceold/scripts/tcw_player.h	2012-02-02 09:44:43.163085900 +0800
+++ source/scripts/tcw_player.h	2012-06-09 08:11:12.169921800 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -24,6 +24,7 @@
 	bool revealed;
 	bool playdetected;
 	bool upgrade_composit_armor_available;
+	bool upgrade_powerpacks_available;
 	bool map_low_grav;
 	bool map_dm_tech1;
 	bool map_dm_tech2;
@@ -33,7 +34,3 @@
 	Vector3 commandocurrpos;
 	Vector3 commandonewpos;
 };
-
-class tcw_I_Have_Ion_Cannon_Beacon : public ScriptImpClass {
-	void Destroyed(GameObject *obj);
-};
\ No newline at end of file
diff -uwr sourceold/scripts/tcw_powerup.cpp source/scripts/tcw_powerup.cpp
--- sourceold/scripts/tcw_powerup.cpp	2012-02-02 09:44:43.112304600 +0800
+++ source/scripts/tcw_powerup.cpp	2012-06-09 08:11:12.222656200 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -18,7 +18,7 @@
 
 void tcw_POW_PickupSounds::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
-	if (message == 1000000025)
+	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
 		if (strstr(Commands->Get_Preset_Name(obj),"TCW_POW_RemoteC4"))
 		{
diff -uwr sourceold/scripts/tcw_powerup.h source/scripts/tcw_powerup.h
--- sourceold/scripts/tcw_powerup.h	2012-02-02 09:44:43.167968700 +0800
+++ source/scripts/tcw_powerup.h	2012-06-09 08:11:12.355468700 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
Only in source/scripts: tcw_raid_at_dawn.cpp
Only in source/scripts: tcw_raid_at_dawn.h
diff -uwr sourceold/scripts/tcw_superweapons.cpp source/scripts/tcw_superweapons.cpp
--- sourceold/scripts/tcw_superweapons.cpp	2012-02-02 09:44:43.160156200 +0800
+++ source/scripts/tcw_superweapons.cpp	2012-06-09 08:11:12.347656200 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -80,7 +80,7 @@
 			}
 			else
 			{
-				if (Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Ion_Center")))
+				if (Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_Ion_Center")))
 				{
 					Send_Message_Player(poker,255,255,255,"Your Ion Cannon Center is destroyed. The Ion Cannon is unavailable.");
 				}
@@ -213,7 +213,7 @@
 			}
 			else 
 			{
-				if (Is_Building_Dead(Find_Building_By_Name(1,"TCW_Temple_of_Nod")))
+				if (Is_Building_Dead(Find_Building_By_Preset(1,"TCW_Temple_of_Nod")))
 				{
 					Send_Message_Player(poker,255,255,255,"Your Temple of Nod is destroyed. The Nuclear Missile is unavailable.");
 				}
@@ -276,9 +276,9 @@
 			GameObject *nukefire = Commands->Create_Object("TCW_Nuclear_Missile_Launch",launchpos);
 			launchnuke = Commands->Get_ID(nukefire);
 			Commands->Set_Facing(nukefire,facing);
-			Commands->Set_Animation(nukefire,"V_MISSLE_FIRE.V_MISSLE_FIRE",false,0,0,39,false);//fire missile animation starts
+			Commands->Set_Animation(nukefire,"V_MISSLE_FIRE.V_MISSLE_FIRE",false,0,0,184,false);//fire missile animation starts
 			Commands->Destroy_Object(Commands->Find_Object(launchready));//remove the nuke idle animation
-			Commands->Start_Timer(obj,this,5.0f,100100);//remove nuke fire thingy
+			Commands->Start_Timer(obj,this,10.0f,100100);//remove nuke fire thingy	
 		}
 		else if (param == 1)
 		{
@@ -320,29 +320,6 @@
 	Auto_Save_Variable(&launchnuke,sizeof(launchnuke),2);
 }
 
-void tcw_nuke_ready::Created(GameObject *obj)
-{
-	//
-}
-void tcw_nuke_ready::Custom(GameObject *obj, int message, int param, GameObject *sender)
-{
-	if (message == 1000)
-	{
-		if (param == 1)//launch the nuke and remove the idle animation
-		{
-			//
-		}
-	}
-}
-
-void tcw_nuke_launch::Created(GameObject *obj)
-{
-	//
-}
-
-ScriptRegistrant<tcw_nuke_ready> tcw_nuke_ready_Registrant("tcw_nuke_ready","");
-ScriptRegistrant<tcw_nuke_launch> tcw_nuke_launch_Registrant("tcw_nuke_launch","");
-
 ScriptRegistrant<tcw_nod_nuke_building> tcw_nod_nuke_building_Registrant("tcw_nod_nuke_building","");
 ScriptRegistrant<tcw_pt_nuke> tcw_pt_nuke_Registrant("tcw_pt_nuke","");
 ScriptRegistrant<tcw_i_have_nuke_beacon> tcw_i_have_nuke_beacon_Registrant("tcw_i_have_nuke_beacon","");
diff -uwr sourceold/scripts/tcw_superweapons.h source/scripts/tcw_superweapons.h
--- sourceold/scripts/tcw_superweapons.h	2012-02-02 09:44:43.178710900 +0800
+++ source/scripts/tcw_superweapons.h	2012-06-09 08:11:12.188476500 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -60,11 +60,3 @@
 int launchnuke;
 };
 
-class tcw_nuke_ready : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Custom(GameObject *obj, int message, int param, GameObject *sender);
-};
-
-class tcw_nuke_launch : public ScriptImpClass {
-	void Created(GameObject *obj);
-};
\ No newline at end of file
diff -uwr sourceold/scripts/tcw_technology.cpp source/scripts/tcw_technology.cpp
--- sourceold/scripts/tcw_technology.cpp	2012-02-02 09:44:43.147460900 +0800
+++ source/scripts/tcw_technology.cpp	2012-06-09 08:11:12.150390600 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -31,7 +31,7 @@
 	{
 		if (Commands->Get_Player_Type(poker) == 1)
 		{
-			if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Armory_Building")))
+			if (!Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_Armory_Building")))
 			{
 				if (!researching_composit_armor_upgrade)
 				{
@@ -87,7 +87,7 @@
 {
 	if (number == 10001)
 	{
-		if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Armory_Building")))
+		if (!Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_Armory_Building")))
 		{
 			Vector3 pos; pos.Z = 999.0f; pos.Y = 999.0f; pos.X = 999.0f;
 			GameObject *compositarmor = Commands->Create_Object("TCW_Tech_Composit_Armor_Available",pos);
@@ -164,7 +164,7 @@
 
 void tcw_steal_tech_zone_gwf::Entered(GameObject *obj, GameObject *enter)
 {
-	if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_War_Factory")))
+	if (!Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_War_Factory")))
 	{
 		if ( (Commands->Is_A_Star(enter)) && (Commands->Get_Player_Type(enter) == 0) )
 		{
@@ -193,7 +193,7 @@
 
 void tcw_steal_tech_zone_nwf::Entered(GameObject *obj, GameObject *enter)
 {
-	if (!Is_Building_Dead(Find_Building_By_Name(0,"TCW_Nod_War_Factory")))
+	if (!Is_Building_Dead(Find_Building_By_Preset(0,"TCW_Nod_War_Factory")))
 	{
 		if ( (Commands->Is_A_Star(enter)) && (Commands->Get_Player_Type(enter) == 1) )
 		{
@@ -222,7 +222,7 @@
 
 void tcw_steal_tech_zone_nhon::Entered(GameObject *obj, GameObject *enter)
 {
-	if (!Is_Building_Dead(Find_Building_By_Name(0,"TCW_Hand_Of_Nod")))
+	if (!Is_Building_Dead(Find_Building_By_Preset(0,"TCW_Hand_Of_Nod")))
 	{
 		if ( (Commands->Is_A_Star(enter)) && (Commands->Get_Player_Type(enter) == 1) )
 		{
@@ -251,7 +251,7 @@
 
 void tcw_steal_tech_zone_gbar::Entered(GameObject *obj, GameObject *enter)
 {
-	if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Barracks")))
+	if (!Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_Barracks")))
 	{
 		if ( (Commands->Is_A_Star(enter)) && (Commands->Get_Player_Type(enter) == 0) )
 		{
@@ -320,7 +320,7 @@
 {
 	if (number == 779901)//nod stole tech from gdi wf
 	{
-		if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_War_Factory")))
+		if (!Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_War_Factory")))
 		{
 			if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
 			{
@@ -348,7 +348,7 @@
 	}
 	else if (number == 779902)//gdi stole tech from nod wf
 	{
-		if (!Is_Building_Dead(Find_Building_By_Name(0,"TCW_Nod_War_Factory")))
+		if (!Is_Building_Dead(Find_Building_By_Preset(0,"TCW_Nod_War_Factory")))
 		{
 			if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
 			{
@@ -377,7 +377,7 @@
 	}
 	else if (number == 779903)//gdi stole tech from nod hand
 	{
-		if (!Is_Building_Dead(Find_Building_By_Name(0,"TCW_Hand_Of_Nod")))
+		if (!Is_Building_Dead(Find_Building_By_Preset(0,"TCW_Hand_Of_Nod")))
 		{
 			if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
 			{
@@ -406,7 +406,7 @@
 	}
 	else if (number == 779904)//nod stole tech from gdi barracks
 	{
-		if (!Is_Building_Dead(Find_Building_By_Name(1,"TCW_GDI_Barracks")))
+		if (!Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_Barracks")))
 		{
 			if (Get_Total_Bullets(obj,"TCW_Weapon_Repairgun_Advanced") == 5)//full repairgun = successful stealing
 			{
@@ -436,7 +436,111 @@
 	}
 }
 
+void tcw_Research_Powerpacks::Created(GameObject *obj)
+{
+	Commands->Enable_HUD_Pokable_Indicator(obj, true);
+	allowpokegdi = true;
+	researching_powerpacks_upgrade = false;
+	researched_powerpacks_upgrade = false;
+	research_powerpacks_cost = 2000.0f;
+	research_powerpacks_fund = 0.0f;
+}
+void tcw_Research_Powerpacks::Poked(GameObject *obj, GameObject *poker)
+{
+	if (allowpokegdi)
+	{
+		if (Commands->Get_Player_Type(poker) == 1)
+		{
+			if (!Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_Armory_Building")))
+			{
+				if (!researching_powerpacks_upgrade)
+				{
+					if (!researched_powerpacks_upgrade)
+					{
+						if (research_powerpacks_fund < 2000.0f)
+						{
+							if (Commands->Get_Money(poker) >= 250.0f)
+							{
+								research_powerpacks_fund += 250.0f;
+								Commands->Give_Money(poker,-250.0f,false);
+								char addedfunds[250];
+								sprintf(addedfunds,"%s added $250 to the Power Packs Upgrade. Current Funds: %g/%g",Get_Player_Name(poker),research_powerpacks_fund,research_powerpacks_cost);
+								Send_Message_Team(1,255,204,0,addedfunds);
+								
+								if (research_powerpacks_fund == 2000.0f)
+								{
+									researching_powerpacks_upgrade = true;
+									Commands->Start_Timer(obj,this,60.0f,10001);
+									Create_2D_WAV_Sound_Team("gdi_tech_upgrade_in_progress.wav",1);
+									Send_Message_Team(1,255,204,0,"Upgrade in progress: Power Packs.");
+									allowpokegdi = false;
+								}
+							}
+							else
+							{
+								Send_Message_Player(poker,255,204,0,"Insufficient funds.");
+								Create_2D_WAV_Sound_Player(poker,"gdi_insufficient_funds.wav");
+							}
+						}
+					}
+					else
+					{
+						Create_2D_WAV_Sound_Player(poker,"incmsg.wav");
+						Send_Message_Player(poker,255,204,0,"Upgrade already performed.");						
+					}
+				}
+				else
+				{
+					Create_2D_WAV_Sound_Player(poker,"gdi_tech_upgrade_in_progress.wav");
+					Send_Message_Player(poker,255,204,0,"Upgrade in progress.");
+				}
+			}
+			else
+			{
+				Create_2D_WAV_Sound_Player(poker,"incmsg.wav");
+				Send_Message_Player(poker,255,204,0,"Sorry, your Armory structure has been destroyed.");
+			}
+		}
+	}
+}
+void tcw_Research_Powerpacks::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 10001)
+	{
+		if (!Is_Building_Dead(Find_Building_By_Preset(1,"TCW_GDI_Armory_Building")))
+		{
+			Vector3 pos; pos.Z = 999.0f; pos.Y = 999.0f; pos.X = 999.0f;
+			GameObject *powerpacks = Commands->Create_Object("TCW_Tech_Power_Packs_Available",pos);
+			Commands->Set_Facing(powerpacks,0.0f);
+			Send_Message_Team(1,255,204,0,"Upgrade Complete: Power Packs.");
+			Create_2D_WAV_Sound_Team("gdi_tech_upgrade_complete.wav",1);
+			researched_powerpacks_upgrade = true;
+			researching_powerpacks_upgrade = false;
+			Commands->Enable_HUD_Pokable_Indicator(obj, false);
+			Send_Custom_Event_To_Object(obj,"TCW_GDI_Zonetrooper",1006,1,2);
+			Send_Custom_Event_To_Object(obj,"TCW_GDI_Zonetrooper_Low",1006,1,2);
+		}
+		else
+		{
+			Send_Message_Team(1,255,204,0,"Upgrading of Power Packs has failed. Structure lost.");
+			Create_2D_WAV_Sound_Team("incmsg.wav",1);
+		}
+	}
+	else if (number == 10002)
+	{
+		allowpokegdi = true;
+	}
+}
+void tcw_Research_Powerpacks::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&researched_powerpacks_upgrade,sizeof(researched_powerpacks_upgrade),1);
+	Auto_Save_Variable(&research_powerpacks_cost,sizeof(research_powerpacks_cost),2);
+	Auto_Save_Variable(&research_powerpacks_fund,sizeof(research_powerpacks_fund),3);
+	Auto_Save_Variable(&researching_powerpacks_upgrade,sizeof(researching_powerpacks_upgrade),4);	
+	Auto_Save_Variable(&allowpokegdi,sizeof(allowpokegdi),5);
+}
 
+ScriptRegistrant<tcw_Research_Powerpacks> tcw_Research_Powerpacks_Registrant("tcw_Research_Powerpacks","");
 ScriptRegistrant<tcw_steal_tech_zone_gbar> tcw_steal_tech_zone_gbar_Registrant("tcw_steal_tech_zone_gbar","");
 ScriptRegistrant<tcw_steal_tech_zone_nhon> tcw_steal_tech_zone_nhon_Registrant("tcw_steal_tech_zone_nhon","");
 ScriptRegistrant<tcw_steal_tech_zone_nwf> tcw_steal_tech_zone_nwf_Registrant("tcw_steal_tech_zone_nwf","");
diff -uwr sourceold/scripts/tcw_technology.h source/scripts/tcw_technology.h
--- sourceold/scripts/tcw_technology.h	2012-02-02 09:44:43.172851500 +0800
+++ source/scripts/tcw_technology.h	2012-06-09 08:11:12.371093700 +0800
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Scripts by zunnie - http://www.tiberiumcrystalwar.com
+	Scripts from - http://www.tiberiumcrystalwar.com
 	Copyright 2011-2012 MPF
 
 	This file is part of the Renegade scripts.dll
@@ -29,7 +29,6 @@
 	void Created(GameObject *obj);
 };
 
-
 class tcw_steal_tech_zone_gwf : public ScriptImpClass {
 	void Entered(GameObject *obj, GameObject *enter);
 	void Exited(GameObject *obj, GameObject *exit);
@@ -54,3 +53,15 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj, int number);
 };
\ No newline at end of file
+
+class tcw_Research_Powerpacks : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Poked(GameObject *obj, GameObject *poker);
+	public: void Register_Auto_Save_Variables();
+	void Timer_Expired(GameObject *obj, int number);
+	bool allowpokegdi;
+	bool researched_powerpacks_upgrade;
+	bool researching_powerpacks_upgrade;
+	float research_powerpacks_cost;
+	float research_powerpacks_fund;
+};
\ No newline at end of file
Only in source/scripts: tcw_tiberium.cpp
Only in source/scripts: tcw_tiberium.h
